﻿Public Class Form2

    Private FontDialog1 As FontDialog = New FontDialog
    Private ColorDialog1 As ColorDialog = New ColorDialog

    ' =============================================================================
    '  FORM EVENTS
    ' =============================================================================
    Private Sub Form2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Text = AppTitleAndVersion("") + " - Properties"
        btn_Edit.Focus()
    End Sub

    Private Sub Form2_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        mObjIndex = -1
        SetCopyPropertyFlag(False)
        If Not ClosingApplication Then
            ShowHideActiveSlots(False)
            Me.Hide()
            e.Cancel = True
        End If
        Form1.FormBorderStyle = Windows.Forms.FormBorderStyle.Fixed3D
    End Sub

    Private Sub Form2_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub


    ' =============================================================================
    '  START EDIT
    ' =============================================================================
    Friend mObjIndex As Int32

    Friend Sub StartEditing(ByVal objIndex As Int32)
        mObjIndex = objIndex
        ShowSelectedObjProps()
        Me.WindowState = FormWindowState.Normal
        ' todo
        If Not Me.Visible Then
            ShowHideActiveSlots(True)
            Me.Show()
            Form1.FormBorderStyle = Windows.Forms.FormBorderStyle.Sizable
            Form1.Focus()
            ' ------------------------------------------------------ Save the first Undo configuration
            If Not Undo1.CanUndo Then Save_Configuration()
        End If
    End Sub

    Friend Sub ShowHideActiveSlots(ByVal visible As Boolean)
        For i As Int32 = 0 To ActiveObjectsArray.Length - 1
            With ActiveObjectsArray(i)
                If .Type = ActiveObjectType.ActiveSlot Then
                    .ActiveSlotControl.Visible = visible
                End If
            End With
        Next
    End Sub

    Friend Sub ShowSelectedObjProps()
        EventsAreEnabled = False
        ' -------------------------------------- 
        chk_AutoLayout.Checked = Form1.AutoLayout
        ' -------------------------------------- Globals
        Combo_SetIndex_FromString(cmb_gTextAlign, gTextAlign.ToString)
        txt_gWidth.Text = gWidth.ToString
        txt_gHeight.Text = gHeight.ToString
        ' -------------------------------------- Selected object
        If mObjIndex < 0 Then
            mObjIndex = 0
        End If
        If mObjIndex > ActiveObjectsArray.Length - 1 Then
            mObjIndex = ActiveObjectsArray.Length - 1
        End If
        If mObjIndex >= 0 Then
            With ActiveObjectsArray(mObjIndex)
                Combo_SetIndex_FromString(cmb_ObjectType, .Type.ToString)
                txt_Top.Text = .Top.ToString
                txt_Left.Text = .Left.ToString
                txt_Width.Text = .Width.ToString
                txt_Height.Text = .Height.ToString
                txt_Text.Text = .Text
                txt_Slot.Text = .SlotString
                Select Case .Type
                    Case ActiveObjectType.Button
                        '
                        cmb_MoveType.Items.Clear()
                        cmb_MoveType.Items.Add("Normal")
                        cmb_MoveType.Items.Add("Partial")
                        cmb_MoveType.Items.Add("Pulse")
                        Combo_SetIndex_FromString(cmb_MoveType, .MoveType)
                        '
                        Combo_SetIndex_FromString(cmb_ObjTextAlign, .ContentAlign.ToString.Replace("Middle", ""))
                        txt_Value.Text = .Value.ToString : txt_Value.Enabled = True
                        txt_Speed.Text = .Speed.ToString
                        txt_Random.Text = .Random.ToString : txt_Random.Enabled = True
                        txt_MultiplierSlot.Text = "" : txt_MultiplierSlot.Enabled = False
                        txt_TriggerSlot.Text = "" : txt_TriggerSlot.Enabled = False
                    Case ActiveObjectType.TextBox
                        '
                        cmb_MoveType.Items.Clear()
                        cmb_MoveType.Items.Add("Normal")
                        '
                        Combo_SetIndex_FromString(cmb_ObjTextAlign, .TextAlign.ToString)
                        txt_Value.Text = "" : txt_Value.Enabled = False
                        txt_Speed.Text = .Speed.ToString
                        txt_Random.Text = "" : txt_Random.Enabled = False
                        txt_MultiplierSlot.Text = .MultiplierSlot.ToString : txt_MultiplierSlot.Enabled = True
                        txt_TriggerSlot.Text = "" : txt_TriggerSlot.Enabled = False
                    Case ActiveObjectType.ActiveSlot
                        '
                        cmb_MoveType.Items.Clear()
                        cmb_MoveType.Items.Add("Normal")
                        cmb_MoveType.Items.Add("OnOff")
                        cmb_MoveType.Items.Add("Sine")
                        Combo_SetIndex_FromString(cmb_MoveType, .MoveType)
                        '
                        Combo_SetIndex_FromString(cmb_ObjTextAlign, .ContentAlign.ToString.Replace("Middle", ""))
                        txt_Value.Text = .Value.ToString : txt_Value.Enabled = True
                        txt_Speed.Text = .Speed.ToString
                        txt_Random.Text = .Random.ToString : txt_Random.Enabled = True
                        txt_MultiplierSlot.Text = "" : txt_MultiplierSlot.Enabled = False
                        txt_TriggerSlot.Text = .TriggerSlot.ToString : txt_TriggerSlot.Enabled = True
                End Select
            End With
            gbox_SelectedObj.Enabled = True
        Else
            gbox_SelectedObj.Enabled = False
        End If
        lbl_ObjectOrder.Text = (mObjIndex + 1).ToString
        ' -------------------------------------- 
        EventsAreEnabled = True
        '
        ShowSelectedObjBorder()
    End Sub

    Private BorderPen As Pen = New Pen(Color.Green, 2)
    Private SelectedObjBorderVisible As Boolean
    Friend Sub ShowSelectedObjBorder()
        InitPanelImageAndGraphics(Form1.FlowLayoutPanel1)
        If mObjIndex >= 0 Then
            SelectedObjBorderVisible = True
            Dim p As Point
            Dim s As Size
            With ActiveObjectsArray(mObjIndex)
                If .TextBox IsNot Nothing Then
                    p = .TextBox.Location
                    s = .TextBox.Size
                End If
                If .Button IsNot Nothing Then
                    p = .Button.Location
                    s = .Button.Size
                End If
                If .ActiveSlotControl IsNot Nothing Then
                    p = .ActiveSlotControl.Location
                    s = .ActiveSlotControl.Size
                End If
            End With
            FlowPanelGraphics.Clear(If(CopyPropertyFlag, CopyHilightColor, gFormColor))
            FlowPanelGraphics.FillRectangle(Brushes.Yellow, p.X - 5, p.Y - 5, s.Width + 10, s.Height + 10)
            FlowPanelGraphics.DrawRectangle(BorderPen, p.X - 5, p.Y - 5, s.Width + 10, s.Height + 10)
            Form1.FlowLayoutPanel1.Refresh()
        Else
            HideSelectedObjBorder()
        End If
    End Sub

    Friend Sub HideSelectedObjBorder()
        If Not SelectedObjBorderVisible Then Return
        SelectedObjBorderVisible = False
        FlowPanelGraphics.Clear(gFormColor)
        Form1.FlowLayoutPanel1.Refresh()
    End Sub

    Private FlowPanelGraphics As Graphics
    Private Sub InitPanelImageAndGraphics(ByVal fpanel As FlowLayoutPanel)
        With fpanel
            If .ClientSize.Width < 1 Or .ClientSize.Height < 1 Then Return
            If .BackgroundImage Is Nothing _
                        OrElse .BackgroundImage.Width <> .ClientSize.Width _
                        OrElse .BackgroundImage.Height <> .ClientSize.Height Then
                .BackgroundImage = New Bitmap(.ClientRectangle.Width, _
                                              .ClientRectangle.Height, _
                                              Imaging.PixelFormat.Format24bppRgb)
                FlowPanelGraphics = Graphics.FromImage(.BackgroundImage)
                FlowPanelGraphics.Clear(Form1.BackColor)
            End If
        End With
    End Sub



    ' =============================================================================
    '  SAVE/LOAD CONFIGURATION
    ' =============================================================================
    Private ConfigurationModified As Boolean = False
    Private Sub btn_LoadConfiguration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_LoadConfiguration.Click
        If ConfigurationModified Then
            If MessageBox.Show("The configuration have been changed." + vbCrLf + _
                               "Maybe you should do a ""Save configuration"" before." + vbCrLf + vbCrLf + _
                               "Proceed and lose changes?", _
                               "WARNING from Theremino Buttons", _
                               MessageBoxButtons.OKCancel, _
                               MessageBoxIcon.Question) <> Windows.Forms.DialogResult.OK Then Return
        End If
        Dim ofd As OpenFileDialog = New OpenFileDialog()
        ofd.InitialDirectory = Application.StartupPath + "\Configurations"
        ofd.Multiselect = True
        ofd.Filter = "Configuration file (*.txt)|*txt"
        ofd.DefaultExt = ".txt"
        IO.Directory.CreateDirectory(ofd.InitialDirectory)
        If ofd.ShowDialog() = Windows.Forms.DialogResult.OK Then
            IO.File.Copy(ofd.FileName, Application.StartupPath + "\Configuration.txt", True)
            Reload_Configuration()
            Undo1.Clear()
            UpdateUndoButtons()
            Form1.SetAutoLayout()
            ShowSelectedObjProps()
            ConfigurationModified = False
        End If
    End Sub

    Private Sub btn_SaveConfiguration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SaveConfiguration.Click
        Dim sfd As SaveFileDialog = New SaveFileDialog()
        sfd.InitialDirectory = Application.StartupPath + "\Configurations"
        sfd.DefaultExt = ".txt"
        sfd.AddExtension = True
        sfd.FileName = "Configuration_" & Date.Now.ToString("yyyy_MM_dd_HH_mm_ss")
        sfd.Filter = "Configuration file (*.txt)|*txt"
        IO.Directory.CreateDirectory(sfd.InitialDirectory)
        If sfd.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Save_Configuration()
            IO.File.Copy(Application.StartupPath + "\Configuration.txt", sfd.FileName, True)
            ConfigurationModified = False
        End If
    End Sub

    ' =============================================================================
    '  EDIT CONFIGURATION
    ' =============================================================================
    Private Sub btn_Edit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Edit.Click
        Form1.Opacity = 0.5
        Me.Opacity = 0.5
        Form1.Enabled = False
        Me.Enabled = False
        ProcessStartAndWait(Application.StartupPath & "\Configuration.txt")
        SendKeys.Flush()
        Form1.Opacity = 1
        Me.Opacity = 1
        Form1.Enabled = True
        Me.Enabled = True
        Reload_Configuration()
        Form1.SetAutoLayout()
        ShowSelectedObjProps()
    End Sub

    Friend Sub Reload_Configuration()
        ActiveSlots.Thread_Stop()
        ActiveSlots.Clear()
        ClearActiveObjects()
        Load_Configuration()
        InitActiveObjects()
        ActiveSlots.Thread_Start()
        Me.Focus()
    End Sub


    ' =============================================================================
    '  EDIT UTILITYES
    ' =============================================================================
    Private Sub btn_AddFonts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_AddFonts.Click
        AddFonts()
    End Sub

    Private Sub btn_CopyProperty_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_CopyProperty.Click
        SetCopyPropertyFlag(Not CopyPropertyFlag)
    End Sub

    Private Sub SetCopyPropertyFlag(ByVal newFlagValue As Boolean)
        CopyPropertyFlag = newFlagValue
        If CopyPropertyFlag Then
            Form1.BackColor = CopyHilightColor
            btn_CopyProperty.Text = "Click destination obj"
            btn_CopyProperty.ForeColor = Color.White
            btn_CopyProperty.BackColor = Color.OrangeRed
            gbox_SelectedObj.BackColor = Color.Gold
        Else
            Form1.BackColor = gFormColor
            btn_CopyProperty.Text = "Copy"
            btn_CopyProperty.ForeColor = Color.Black
            btn_CopyProperty.BackColor = Color.FromArgb(255, 240, 150)
            gbox_SelectedObj.BackColor = gbox_Configuration.BackColor
        End If
        ShowSelectedObjBorder()
    End Sub

    Friend Sub CopyProperty(ByVal DestObjIndex As Int32)
        Dim srcObj As ActiveObject = ActiveObjectsArray(mObjIndex)
        With ActiveObjectsArray(DestObjIndex)
            Select Case cmb_CopyProperty.Text
                Case "All properties"
                    .Type = srcObj.Type
                    .TextFont = srcObj.TextFont
                    .TextAlign = srcObj.TextAlign
                    .ContentAlign = srcObj.ContentAlign
                    .TextColor = srcObj.TextColor
                    .BackColor = srcObj.BackColor
                    .Left = srcObj.Left : .Top = srcObj.Top
                    .Width = srcObj.Width : .Height = srcObj.Height
                    .Text = srcObj.Text
                    .SlotString = srcObj.SlotString
                    .SlotArray = srcObj.SlotArray
                    .Value = srcObj.Value
                    .Speed = srcObj.Speed
                    .Random = srcObj.Random
                    .MultiplierSlot = srcObj.MultiplierSlot
                    .TriggerSlot = srcObj.TriggerSlot
                    .MoveType = srcObj.MoveType
                Case "All colors"
                    .TextColor = srcObj.TextColor
                    .BackColor = srcObj.BackColor
                Case "Text" : .Text = srcObj.Text
                Case "Type" : .Type = srcObj.Type
                Case "Font" : .TextFont = srcObj.TextFont
                Case "Alignment"
                    .TextAlign = srcObj.TextAlign
                    .ContentAlign = srcObj.ContentAlign
                Case "Text color" : .TextColor = srcObj.TextColor
                Case "Back color" : .BackColor = srcObj.BackColor
                Case "Position and Size"
                    .Left = srcObj.Left : .Top = srcObj.Top
                    .Width = srcObj.Width : .Height = srcObj.Height
                Case "Slot"
                    .SlotString = srcObj.SlotString
                    .SlotArray = srcObj.SlotArray
                Case "Value" : .Value = srcObj.Value
                Case "Speed" : .Speed = srcObj.Speed
                Case "Random" : .Random = srcObj.Random
                Case "Multiplier slot" : .MultiplierSlot = srcObj.MultiplierSlot
                Case "Trigger slot" : .TriggerSlot = srcObj.TriggerSlot
                Case "MoveType" : .MoveType = srcObj.MoveType
            End Select
        End With
        Save_Configuration()
        Reload_Configuration()
    End Sub


    ' =============================================================================
    '  EDIT FORM PROPS
    ' =============================================================================
    Private Sub chk_AutoLayout_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_AutoLayout.CheckedChanged
        If Not EventsAreEnabled Then Return
        Form1.AutoLayout = chk_AutoLayout.Checked
        Form1.SetAutoLayout()
        Save_Configuration()
        ShowSelectedObjBorder()
        Form1.Focus()
    End Sub

    Private Sub btn_FormBackColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_FormBackColor.Click
        ColorDialog1.Color = gFormColor
        SendKeys.Send("{TAB}{TAB}{ENTER}")
        If ColorDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            gFormColor = ColorDialog1.Color
            Save_Configuration()
            Reload_Configuration()
            ShowSelectedObjBorder()
        End If
    End Sub

    ' =============================================================================
    '  EDIT GLOBALS
    ' =============================================================================
    Private Sub btn_gTextFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_gTextFont.Click
        FontDialog1.Font = gTextFont
        If FontDialog1.ShowDialog <> Windows.Forms.DialogResult.Cancel Then
            gTextFont = FontDialog1.Font
            For i As Int32 = 0 To ActiveObjectsArray.Length - 1
                ActiveObjectsArray(i).TextFont = gTextFont
            Next
            Save_Configuration()
            Reload_Configuration()
        End If
    End Sub
    Private Sub cmb_gTextAlign_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_gTextAlign.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        gTextAlign = cmb_gTextAlign.Text
        For i As Int32 = 0 To ActiveObjectsArray.Length - 1
            With ActiveObjectsArray(i)
                .ContentAlign = DecodeContentAlignment(gTextAlign)
                .TextAlign = DecodeHorizontalAlignment(gTextAlign)
            End With
        Next
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjProps()
    End Sub
    Private Sub btn_gTextColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_gTextColor.Click
        ColorDialog1.Color = gTextColor
        SendKeys.Send("{TAB}{TAB}{ENTER}")
        If ColorDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            gTextColor = ColorDialog1.Color
            For i As Int32 = 0 To ActiveObjectsArray.Length - 1
                ActiveObjectsArray(i).TextColor = gTextColor
            Next
            Save_Configuration()
            Reload_Configuration()
        End If
    End Sub
    Private Sub btn_gBackColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_gBackColor.Click
        ColorDialog1.Color = gBackColor
        SendKeys.Send("{TAB}{TAB}{ENTER}")
        If ColorDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            gBackColor = ColorDialog1.Color
            For i As Int32 = 0 To ActiveObjectsArray.Length - 1
                ActiveObjectsArray(i).BackColor = gBackColor
            Next
            Save_Configuration()
            Reload_Configuration()
        End If
    End Sub

    Private Sub txt_gSizeW_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_gWidth.TextChanged
        If Not EventsAreEnabled Then Return
        gWidth = CInt(Val(txt_gWidth.Text))
        For i As Int32 = 0 To ActiveObjectsArray.Length - 1
            ActiveObjectsArray(i).Width = gWidth
        Next
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjBorder()
    End Sub
    Private Sub txt_gSizeH_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_gHeight.TextChanged
        If Not EventsAreEnabled Then Return
        gHeight = CInt(Val(txt_gHeight.Text))
        For i As Int32 = 0 To ActiveObjectsArray.Length - 1
            ActiveObjectsArray(i).Height = gHeight
        Next
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjBorder()
    End Sub


    ' =============================================================================
    '  EDIT SELECTED OBJECT
    ' =============================================================================
    Private Sub txt_Text_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Text.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).Text = txt_Text.Text
        Save_Configuration()
        Reload_Configuration()
    End Sub

    Private Sub cmb_ObjectType_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ObjectType.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        If mObjIndex < 0 Then Return
        With ActiveObjectsArray(mObjIndex)
            Select Case cmb_ObjectType.SelectedItem.ToString
                Case "Button"
                    .Type = ActiveObjectType.Button
                    If .Text = "TextBox" Or .Text = "ActiveSlot" Then .Text = "Button"
                Case "TextBox"
                    .Type = ActiveObjectType.TextBox
                    If .Text = "Button" Or .Text = "ActiveSlot" Then .Text = "TextBox"
                Case "ActiveSlot"
                    .Type = ActiveObjectType.ActiveSlot
                    InitObjectDefaultProps(mObjIndex, "ActiveSlot")
                    If .Text = "Button" Or .Text = "TextBox" Then .Text = "ActiveSlot"
            End Select
        End With
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjProps()
    End Sub
    Private Sub cmb_ObjTextAlign_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_ObjTextAlign.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        If mObjIndex < 0 Then Return
        AlignmentFromText(mObjIndex, cmb_ObjTextAlign.Text)
        ShowSelectedObjProps()
        Save_Configuration()
        Reload_Configuration()
    End Sub

    Private Sub AlignmentFromText(ByVal objindex As Int32, ByVal alignment As String)
        With ActiveObjectsArray(objindex)
            Select Case .Type
                Case ActiveObjectType.TextBox
                    Select Case alignment
                        Case "Left" : .TextBox.TextAlign = HorizontalAlignment.Left
                        Case "Center" : .TextBox.TextAlign = HorizontalAlignment.Center
                        Case "Right" : .TextBox.TextAlign = HorizontalAlignment.Right
                    End Select
                    ActiveObjectsArray(objindex).TextAlign = DecodeHorizontalAlignment(alignment)
                Case ActiveObjectType.Button
                    Select Case alignment
                        Case "Left" : .Button.TextAlign = ContentAlignment.MiddleLeft
                        Case "Center" : .Button.TextAlign = ContentAlignment.MiddleCenter
                        Case "Right" : .Button.TextAlign = ContentAlignment.MiddleRight
                    End Select
                    ActiveObjectsArray(objindex).ContentAlign = DecodeContentAlignment(alignment)
                Case ActiveObjectType.ActiveSlot
                    Select Case alignment
                        Case "Left" : .ActiveSlotControl.TextAlign = ContentAlignment.MiddleLeft
                        Case "Center" : .ActiveSlotControl.TextAlign = ContentAlignment.MiddleCenter
                        Case "Right" : .ActiveSlotControl.TextAlign = ContentAlignment.MiddleRight
                    End Select
                    ActiveObjectsArray(objindex).ContentAlign = DecodeContentAlignment(alignment)
            End Select
        End With
    End Sub

    Private Sub btn_TextFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_TextFont.Click
        FontDialog1.Font = ActiveObjectsArray(mObjIndex).TextFont
        If FontDialog1.ShowDialog <> Windows.Forms.DialogResult.Cancel Then
            ActiveObjectsArray(mObjIndex).TextFont = FontDialog1.Font
            Save_Configuration()
            Reload_Configuration()
        End If
    End Sub

    Private Sub btn_TextColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_TextColor.Click
        ColorDialog1.Color = ActiveObjectsArray(mObjIndex).TextColor
        SendKeys.Send("{TAB}{TAB}{ENTER}")
        If ColorDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            ActiveObjectsArray(mObjIndex).TextColor = ColorDialog1.Color
            Save_Configuration()
            Reload_Configuration()
        End If
    End Sub
    Private Sub btn_BackColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_BackColor.Click
        ColorDialog1.Color = ActiveObjectsArray(mObjIndex).BackColor
        SendKeys.Send("{TAB}{TAB}{ENTER}")
        If ColorDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            ActiveObjectsArray(mObjIndex).BackColor = ColorDialog1.Color
            Save_Configuration()
            Reload_Configuration()
        End If
    End Sub

    Private Sub txt_Left_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Left.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).Left = CInt(Val(txt_Left.Text))
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjBorder()
    End Sub
    Private Sub txt_Top_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Top.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).Top = CInt(Val(txt_Top.Text))
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjBorder()
    End Sub
    Private Sub txt_SizeW_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Width.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).Width = CInt(Val(txt_Width.Text))
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjBorder()
    End Sub
    Private Sub txt_SizeH_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Height.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).Height = CInt(Val(txt_Height.Text))
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjBorder()
    End Sub


    ' =============================================================================
    '  SLOTS PROPERTIES
    ' =============================================================================
    Private Sub txt_Slot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Slot.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).SlotString = txt_Slot.Text
        ActiveObjectsArray(mObjIndex).SlotArray = StringToSlotArray(txt_Slot.Text)
        Save_Configuration()
        Reload_Configuration()
    End Sub
    Private Sub txt_Value_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Value.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).Value = CSng(Val(txt_Value.Text))
        Save_Configuration()
        Reload_Configuration()
    End Sub
    Private Sub txt_Speed_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Speed.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).Speed = CSng(Val(txt_Speed.Text))
        Save_Configuration()
        Reload_Configuration()
    End Sub
    Private Sub txt_Random_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Random.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).Random = CSng(Val(txt_Random.Text))
        Save_Configuration()
        Reload_Configuration()
    End Sub
    Private Sub txt_MultiplierSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_MultiplierSlot.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).MultiplierSlot = CInt(Val(txt_MultiplierSlot.Text))
        Save_Configuration()
        Reload_Configuration()
    End Sub
    Private Sub txt_TriggerSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_TriggerSlot.TextChanged
        If Not EventsAreEnabled Then Return
        ActiveObjectsArray(mObjIndex).TriggerSlot = CInt(Val(txt_TriggerSlot.Text))
        Save_Configuration()
        Reload_Configuration()
    End Sub
    Private Sub cmb_MoveType_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_MoveType.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        If mObjIndex < 0 Then Return
        ActiveObjectsArray(mObjIndex).MoveType = cmb_MoveType.Text
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjProps()
    End Sub


    ' =============================================================================
    '  EDIT OBJECTS
    ' =============================================================================
    Private Sub btn_Undo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Undo.Click
        If Undo1.CanUndo Then
            ActiveSlots.Thread_Stop()
            ActiveSlots.Clear()
            ClearActiveObjects()
            DecodeUndoRedoString(Undo1.GetUndoEntry())
            UpdateUndoButtons()
            InitActiveObjects()
            ActiveSlots.Thread_Start()
            ShowSelectedObjProps()
            Me.Focus()
        End If
    End Sub
    Private Sub btn_Redo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Redo.Click
        If Undo1.CanRedo Then
            ActiveSlots.Thread_Stop()
            ActiveSlots.Clear()
            ClearActiveObjects()
            DecodeUndoRedoString(Undo1.GetRedoEntry())
            UpdateUndoButtons()
            InitActiveObjects()
            ActiveSlots.Thread_Start()
            ShowSelectedObjProps()
            Me.Focus()
        End If
    End Sub
    Friend Sub UpdateUndoButtons()
        btn_Undo.Enabled = Undo1.CanUndo
        btn_Redo.Enabled = Undo1.CanRedo
        ConfigurationModified = btn_Undo.Enabled
    End Sub

    Private Sub btn_SelectPreviousObj_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SelectPreviousObj.Click
        If mObjIndex > 0 Then
            mObjIndex -= 1
            Save_Configuration()
            Reload_Configuration()
            ShowSelectedObjProps()
        End If
    End Sub
    Private Sub btn_SelectNextObj_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SelectNextObj.Click
        If mObjIndex < ActiveObjectsArray.Length - 1 Then
            mObjIndex += 1
            Save_Configuration()
            Reload_Configuration()
            ShowSelectedObjProps()
        End If
    End Sub

    Private Sub btn_MoveBefore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_MoveBefore.Click
        If mObjIndex > 0 Then
            Swap(ActiveObjectsArray(mObjIndex), ActiveObjectsArray(mObjIndex - 1))
            SwapGraphicControlsLocations(mObjIndex, mObjIndex - 1)
            mObjIndex -= 1
            Save_Configuration()
            Reload_Configuration()
            ShowSelectedObjProps()
        End If
    End Sub
    Private Sub btn_MoveAfter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_MoveAfter.Click
        If mObjIndex < ActiveObjectsArray.Length - 1 Then
            Swap(ActiveObjectsArray(mObjIndex), ActiveObjectsArray(mObjIndex + 1))
            SwapGraphicControlsLocations(mObjIndex, mObjIndex + 1)
            mObjIndex += 1
            Save_Configuration()
            Reload_Configuration()
            ShowSelectedObjProps()
        End If
    End Sub

    Private Sub btn_AddNewObj_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_AddNewObj.Click
        Form1.AutoSize = True
        Form1.FlowLayoutPanel1.AutoSize = True
        ReDim Preserve ActiveObjectsArray(ActiveObjectsArray.Length)
        If ActiveObjectsArray.Length = 1 Then
            mObjIndex = 0
            InitObjectDefaultProps(mObjIndex, "Button")
            ActiveObjectsArray(mObjIndex).Text = "Button"
        Else
            For i As Int32 = ActiveObjectsArray.Length - 2 To mObjIndex Step -1
                ActiveObjectsArray(i + 1) = ActiveObjectsArray(i)
            Next
            mObjIndex += 1

            If Not Form1.AutoLayout Then
                Dim obj As ActiveObject = ActiveObjectsArray(mObjIndex - 1)
                With ActiveObjectsArray(mObjIndex)
                    .Left = obj.Left + 30
                    .Top = obj.Top + 30
                End With
            End If
        End If
        Save_Configuration()
        Reload_Configuration()
        ShowSelectedObjProps()
        Dim s As Size = Form1.Size
        Form1.AutoSize = False
        Form1.FlowLayoutPanel1.AutoSize = False
        Form1.Size = s
    End Sub
    Private Sub btn_DeleteSelectedObj_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DeleteSelectedObj.Click
        If mObjIndex >= 0 Then
            For i As Int32 = mObjIndex To ActiveObjectsArray.Length - 2
                ActiveObjectsArray(i) = ActiveObjectsArray(i + 1)
            Next
            If mObjIndex >= ActiveObjectsArray.Length - 1 Then mObjIndex -= 1
            ReDim Preserve ActiveObjectsArray(ActiveObjectsArray.Length - 2)
            Save_Configuration()
            Reload_Configuration()
            ShowSelectedObjProps()
        End If
    End Sub


    ' =============================================================================
    '  EDIT OBJECTS POSITION WITH ARROWS
    ' =============================================================================
    Friend Sub ChangeSelectedObjectPositionAndDimension(ByVal dx As Int32, _
                                                        ByVal dy As Int32, _
                                                        ByVal dw As Int32, _
                                                        ByVal dh As Int32)
        With ActiveObjectsArray(mObjIndex)
            If txt_Left.Enabled Then .Left += dx
            If txt_Top.Enabled Then .Top += dy
            .Width += dw
            .Height += dh
            '
            Limit(.Left, 0, 1999)
            Limit(.Top, 0, 1999)
            Limit(.Width, 10, 1999)
            Limit(.Height, 10, 1999)
            '
            If .TextBox IsNot Nothing Then
                .TextBox.Left = .Left
                .TextBox.Top = .Top
                .TextBox.Width = .Width
                .TextBox.Height = .Height
            End If
            If .Button IsNot Nothing Then
                .Button.Left = .Left
                .Button.Top = .Top
                .Button.Width = .Width
                .Button.Height = .Height
            End If
            If .ActiveSlotControl IsNot Nothing Then
                .ActiveSlotControl.Left = .Left
                .ActiveSlotControl.Top = .Top
                .ActiveSlotControl.Width = .Width
                .ActiveSlotControl.Height = .Height
            End If
            '
            EventsAreEnabled = False
            txt_Left.Text = .Left.ToString
            txt_Top.Text = .Top.ToString
            txt_Width.Text = .Width.ToString
            txt_Height.Text = .Height.ToString
            EventsAreEnabled = True
        End With
        '
        HideSelectedObjBorder()
    End Sub

    Private Sub Limit(ByRef n As Int32, ByVal min As Int32, ByVal max As Int32)
        If n < min Then n = min
        If n > max Then n = max
    End Sub

    Friend Sub EndMoveControl()
        Save_Configuration()
        ' -------------------------------- reload configuration without Me.Focus
        ActiveSlots.Thread_Stop()
        ActiveSlots.Clear()
        ClearActiveObjects()
        Load_Configuration()
        InitActiveObjects()
        ActiveSlots.Thread_Start()
    End Sub

    Friend Sub CopyPlacementFromControlsToActiveObjectsArray()
        For i As Int32 = 0 To ActiveObjectsArray.Length - 1
            With ActiveObjectsArray(i)
                If .TextBox IsNot Nothing Then
                    .Left = .TextBox.Left
                    .Top = .TextBox.Top
                    .Width = .TextBox.Width
                    .Height = .TextBox.Height
                End If
                If .Button IsNot Nothing Then
                    .Left = .Button.Left
                    .Top = .Button.Top
                    .Width = .Button.Width
                    .Height = .Button.Height
                End If
                If .ActiveSlotControl IsNot Nothing Then
                    .Left = .ActiveSlotControl.Left
                    .Top = .ActiveSlotControl.Top
                    .Width = .ActiveSlotControl.Width
                    .Height = .ActiveSlotControl.Height
                End If
            End With
        Next
    End Sub

End Class